<?php
/*******************************************************************************
	This is a script to add settings into SMF.

	ATTENTION: If you are trying to INSTALL this package, please access
	it directly, with a URL like the following:
		http://www.yourdomain.tld/forum/add_settings.php (or similar.)

================================================================================

	This script can be used to add new settings into the database for use
	with SMF's $modSettings array.  It is meant to be run either from the
	package manager or directly by URL.

*******************************************************************************/

// Do we want to overwrite previous settings?
$overwrite_old_settings = false;

// List of settings and their default values
$mod_settings = array(
	'bnews_enabled' => 0 ,
	'bnews_max' => 4,
	'bnews_chars' => 80,
	'bnews_hover' => 120,
);

/******************************************************************************/

// If SSI.php is in the same place as this file, and SMF isn't defined, this is being run standalone.
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

/********************************************
 * Dependancy checker v1.0                  *
 * Author: jake1981/Oskari Rauta/Jake Irons *
 * URL: http://www.roadrunner.cx            *
 * mail: jake1981@luukku.com                *
 * (C) RoadRunner.cx, 2007                  *
 *                                          *
 * Feel free to use my dependancy checker   *
 * for free but keep this banner in source  *
 * code. In your software or your docs      *
 * you do not need to mention anything      *
 * about me or my code.                     *
 ********************************************/
 
	$DepsOK = 1;

  $Deps = array(
		array('name' => 'ssi_boardNews Multiple Boards',
					'download' => 'http://custom.simplemachines.org/mods/index.php?mod=759',
					'author' => 'Daniel15',
					'authormail' => 'http://www.daniel15.com',
					'is_installed' => 0
					)
				);

	$listFile = file_get_contents($boarddir . '/Packages/installed.list');

	if (strpos($listFile, "\n") !== false)
		$listFile = explode("\n", $listFile);
	elseif (strpos($listFile, "\r") !== false)
		$listFile = explode("\r", $listFile);
	else
		return 0;

	foreach($listFile as $listLine)
		foreach ($Deps as &$depend)
			if (substr($listLine, 0, strlen($depend['name'])) == $depend['name'])
				$depend['is_installed'] = 1;

	unset($listFile); //Release memory

	foreach($Deps as $depend)
		if (!$depend['is_installed'])
			$DepsOK = 0;

	if (!$DepsOK)
		{
		echo '<HTML>
<HEAD>
	<TITLE>boardNews MOD installation</TITLE>
</HEAD>
<BODY STYLE="background-color: #E5E5E8; margin: 10px; font-family: arial; font-size: 12px;">
	<br/>
	<br/>
	<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" WIDTH="100%" STYLE="background-color: #F6F6F6; border: solid 1px #696969; margin: 2px; padding: 2px;">
		<TR>
			<TD COLSPAN="2" STYLE="text-align:left;vertical-align:middle;font-weight:bold;text-decoration:none;border-bottom:dashed 2px #9BAEBF;padding: 1px; margin: 1px 1px 0px 1px; background-color: #C0CEDB;">
				boardNews MOD Installation failure
			</TD>
		</TR>
		<TR><TD COLSPAN="2">&nbsp;</TD></TR>
		<TR><TD COLSPAN="2">boardNews<br/>
Author: Oskari Rauta/Jake Irons<br/>
Contact: jake1981@luukku.com<br/>
<br/>
You cannot install boardNews because it has not met it\'s
dependency list. It depends on following MODS that have not
been installed:<br/><br/>
<hr/>';

		foreach ($Deps as $depend)
			if (!$depend['is_installed'])
				echo '
Name: <a href="' . $depend['download'] . '">' . $depend['name'] . '</a><br/>
Author: <a href="' . $depend['authormail'] . '">' . $depend['author'] . '</a><br/>
<hr/>';

		echo '
<br/>
Please, install required MOD(s) before installing
boardNews modificiation.<br/><br/>
All changes to your forum have been cancelled.<br/>
Click <B><a href="' . $boardurl . '">here</a></B> to return
to your forum.<br/><br/>
</TD></TR>
			<TR><TD COLSPAN="2">&nbsp;</TD></TR>
		</TABLE>
</BODY>
</HTML>
';
		die(0);
		}

// Dependancy checker ends here..

// Turn the array defined above into a string of MySQL data.
$string = '';
foreach ($mod_settings as $k => $v)
	$string .= '
			(\'' . $k . '\', \'' . $v . '\'),';

// Insert to DB
if ($string != '')
	$result = db_query("
		" . ($overwrite_old_settings ? 'REPLACE' : 'INSERT IGNORE') . " INTO {$db_prefix}settings
			(variable, value)
		VALUES" . substr($string, 0, -1), __FILE__, __LINE__);

// Cannot write settings to db
if (!$result)
	echo '<b>Error:</b> Database modifications failed!';

?>